Difference between revisions of "Mesh to Part/de"

From FreeCAD Documentation
Jump to: navigation, search
 
(7 intermediate revisions by the same user not shown)
Line 2: Line 2:
 
{{docnav/de|Topological data scripting/de|Scenegraph/de}}
 
{{docnav/de|Topological data scripting/de|Scenegraph/de}}
  
== Konvertieren von Bauteilobjekten in Drahtmodelle (mesh) ==
+
== Umwandeln von Bauteilobjekten in Polygonnetze ==
  
Die Konvertierung von übergeordneten Objekten wie [[Part Module/de|Teilformen]] in einfachere Objekte wie [[Mesh Module/de|Drahtmodelle (mesh)]] ist eine sehr einfache Operation, bei der alle Flächen eines Teilobjekts trianguliert werden. Das Ergebnis dieser Triangulation (Tesselierung) wird dann zum Aufbau eines Drahtmodells (mesh) verwendet: (nehmen wir an, unser Dokument enthält ein Teilobjekt)
+
Die Konvertierung von übergeordneten Objekten wie [[Part Module/de|Teilformen]] in einfachere Objekte wie [[Mesh Module/de|Polygonnetze]] ist eine sehr einfache Operation, bei der alle Flächen eines Teilobjekts trianguliert werden. Das Ergebnis dieser Triangulation (Tesselierung) wird dann zum Aufbau eines Polygonnetzes verwendet: (nehmen wir an, unser Dokument enthält ein Teilobjekt)
 
{{Code|code=
 
{{Code|code=
 
#let's assume our document contains one part object
 
#let's assume our document contains one part object
Line 20: Line 20:
 
Mesh.show(m)
 
Mesh.show(m)
 
}}
 
}}
Manchmal ist die Triangulation bestimmter Flächen, die OpenCascade anbietet, ziemlich hässlich. Wenn die Fläche einen rechteckigen Parameterraum hat und keine Löcher oder andere Beschnittkurven enthält, kannst Du auch selbst ein Drahtmodel (mesh) erstellen:
+
Manchmal ist die Triangulation bestimmter Flächen, die OpenCascade anbietet, ziemlich hässlich. Wenn die Fläche einen rechteckigen Parameterraum hat und keine Löcher oder andere Beschnittkurven enthält, kannst Du auch selbst ein Polygonnetz erstellen:
 
{{Code|code=
 
{{Code|code=
 
import Mesh
 
import Mesh
Line 40: Line 40:
 
return mesh
 
return mesh
 
}}
 
}}
== Konvertieren von Drahtmodellen (mesh) in Bauteilobjekte ==
+
== Konvertieren von Polygonnetzen in Bauteilobjekte ==
  
Die Umwandlung von Drahtmodellen (mesh) in Bauteilobjekte ist ein äußerst wichtiger Vorgang in der CAD Arbeit, da man sehr oft 3D Daten im Drahtmodell-Format (mesh) von anderen Personen erhält oder diese aus anderen Anwendungen ausgegeben werden. Drahtmodelle (mesh) sind sehr praktisch, um Freiformgeometrien und große visuelle Szenen darzustellen, da sie sehr leicht sind, aber für CAD bevorzugen wir im Allgemeinen übergeordnete Objekte, die viel mehr Informationen enthalten, wie z.B. die Idee des Solid oder Flächen aus Kurven statt Dreiecken.
+
Die Umwandlung von Polygonnetzen in Bauteilobjekte ist ein äußerst wichtiger Vorgang in der CAD Arbeit, da man sehr oft 3D Daten im Polygonnetzformat von anderen Personen erhält oder diese aus anderen Anwendungen ausgegeben werden. Polygonnetze sind sehr praktisch, um Freiformgeometrien und große visuelle Szenen darzustellen, da sie sehr leicht sind, aber für CAD bevorzugen wir im Allgemeinen übergeordnete Objekte, die viel mehr Informationen enthalten, wie z.B. die Idee des Festkörpers oder Flächen aus Kurven statt Dreiecken.
  
Die Konvertierung von Drahtmodellen (mesh) in diese übergeordneten Objekte (die vom [[Part Module/de]] in FreeCAD verwaltet werden) ist keine leichte Aufgabe. Drahtmodelle (mesh) können aus Tausenden von Dreiecken bestehen (z.B. wenn sie von einem 3D Scanner erzeugt werden), und Körper mit derselben Anzahl von Flächen zu haben, wäre extrem schwer zu manipulieren. Daher ist es in der Regel sinnvoll, das Objekt bei der Konvertierung zu optimieren.
+
Die Konvertierung von Polygonnetzen in diese übergeordneten Objekte (die vom [[Part Module/de]] in FreeCAD verwaltet werden) ist keine leichte Aufgabe. Polygonnetze können aus Tausenden von Dreiecken bestehen (z.B. wenn sie von einem 3D Scanner erzeugt werden), und Körper mit derselben Anzahl von Flächen zu haben, wäre extrem schwer zu manipulieren. Daher ist es in der Regel sinnvoll, das Objekt bei der Konvertierung zu optimieren.
  
FreeCAD bietet derzeit zwei Möglichkeiten, Drahtmodelle (mesh) in Bauteilobjekte zu konvertieren. Die erste Methode ist eine einfache, direkte Umwandlung, ohne jegliche Optimierung:
+
FreeCAD bietet derzeit zwei Möglichkeiten, Polygonnetze in Bauteilobjekte zu konvertieren. Die erste Methode ist eine einfache, direkte Umwandlung, ohne jegliche Optimierung:
 
{{Code|code=
 
{{Code|code=
 
import Mesh,Part
 
import Mesh,Part
Line 56: Line 56:
  
 
}}
 
}}
Die zweite Methode bietet die Möglichkeit, Drahtmodellfacetten koplanar zu betrachten, wenn der Winkel zwischen ihnen unter einem bestimmten Wert liegt. Dies ermöglicht es, viel einfachere Formen zu bauen: (nehmen wir an, unser Dokument enthält ein Drahtmodelobjekt (mesh Objekt)).
+
Die zweite Methode bietet die Möglichkeit, Polygonnetz Facetten koplanar zu betrachten, wenn der Winkel zwischen ihnen unter einem bestimmten Wert liegt. Dies ermöglicht es, viel einfachere Formen zu bauen: (nehmen wir an, unser Dokument enthält ein Polygonnetzeobjekt).
 
{{Code|code=
 
{{Code|code=
 
# let's assume our document contains one Mesh object
 
# let's assume our document contains one Mesh object

Latest revision as of 10:34, 5 January 2020

Other languages:
čeština • ‎Deutsch • ‎English • ‎español • ‎français • ‎Bahasa Indonesia • ‎italiano • ‎日本語 • ‎română • ‎русский • ‎svenska • ‎Türkçe

Umwandeln von Bauteilobjekten in Polygonnetze

Die Konvertierung von übergeordneten Objekten wie Teilformen in einfachere Objekte wie Polygonnetze ist eine sehr einfache Operation, bei der alle Flächen eines Teilobjekts trianguliert werden. Das Ergebnis dieser Triangulation (Tesselierung) wird dann zum Aufbau eines Polygonnetzes verwendet: (nehmen wir an, unser Dokument enthält ein Teilobjekt)

#let's assume our document contains one part object
import Mesh
faces = []
shape = FreeCAD.ActiveDocument.ActiveObject.Shape
triangles = shape.tessellate(1) # the number represents the precision of the tessellation)
for tri in triangles[1]:
    face = []
    for i in range(3):
        vindex = tri[i]
        face.append(triangles[0][vindex])
    faces.append(face)
m = Mesh.Mesh(faces)
Mesh.show(m)

Manchmal ist die Triangulation bestimmter Flächen, die OpenCascade anbietet, ziemlich hässlich. Wenn die Fläche einen rechteckigen Parameterraum hat und keine Löcher oder andere Beschnittkurven enthält, kannst Du auch selbst ein Polygonnetz erstellen:

import Mesh
def makeMeshFromFace(u,v,face):
	(a,b,c,d)=face.ParameterRange
	pts=[]
	for j in range(v):
		for i in range(u):
			s=1.0/(u-1)*(i*b+(u-1-i)*a)
			t=1.0/(v-1)*(j*d+(v-1-j)*c)
			pts.append(face.valueAt(s,t))

	mesh=Mesh.Mesh()
	for j in range(v-1):
		for i in range(u-1):
			mesh.addFacet(pts[u*j+i],pts[u*j+i+1],pts[u*(j+1)+i])
			mesh.addFacet(pts[u*(j+1)+i],pts[u*j+i+1],pts[u*(j+1)+i+1])

	return mesh

Konvertieren von Polygonnetzen in Bauteilobjekte

Die Umwandlung von Polygonnetzen in Bauteilobjekte ist ein äußerst wichtiger Vorgang in der CAD Arbeit, da man sehr oft 3D Daten im Polygonnetzformat von anderen Personen erhält oder diese aus anderen Anwendungen ausgegeben werden. Polygonnetze sind sehr praktisch, um Freiformgeometrien und große visuelle Szenen darzustellen, da sie sehr leicht sind, aber für CAD bevorzugen wir im Allgemeinen übergeordnete Objekte, die viel mehr Informationen enthalten, wie z.B. die Idee des Festkörpers oder Flächen aus Kurven statt Dreiecken.

Die Konvertierung von Polygonnetzen in diese übergeordneten Objekte (die vom Part Module/de in FreeCAD verwaltet werden) ist keine leichte Aufgabe. Polygonnetze können aus Tausenden von Dreiecken bestehen (z.B. wenn sie von einem 3D Scanner erzeugt werden), und Körper mit derselben Anzahl von Flächen zu haben, wäre extrem schwer zu manipulieren. Daher ist es in der Regel sinnvoll, das Objekt bei der Konvertierung zu optimieren.

FreeCAD bietet derzeit zwei Möglichkeiten, Polygonnetze in Bauteilobjekte zu konvertieren. Die erste Methode ist eine einfache, direkte Umwandlung, ohne jegliche Optimierung:

import Mesh,Part
mesh = Mesh.createTorus()
shape = Part.Shape()
shape.makeShapeFromMesh(mesh.Topology,0.05) # the second arg is the tolerance for sewing
solid = Part.makeSolid(shape)
Part.show(solid)

Die zweite Methode bietet die Möglichkeit, Polygonnetz Facetten koplanar zu betrachten, wenn der Winkel zwischen ihnen unter einem bestimmten Wert liegt. Dies ermöglicht es, viel einfachere Formen zu bauen: (nehmen wir an, unser Dokument enthält ein Polygonnetzeobjekt).

# let's assume our document contains one Mesh object
import Mesh,Part,MeshPart
faces = []
mesh = App.ActiveDocument.ActiveObject.Mesh
segments = mesh.getPlanes(0.00001) # use rather strict tolerance here
 
for i in segments:
  if len(i) > 0:
     # a segment can have inner holes
     wires = MeshPart.wireFromSegment(mesh, i)
     # we assume that the exterior boundary is that one with the biggest bounding box
     if len(wires) > 0:
        ext=None
        max_length=0
        for i in wires:
           if i.BoundBox.DiagonalLength > max_length:
              max_length = i.BoundBox.DiagonalLength
              ext = i

        wires.remove(ext)
        # all interior wires mark a hole and must reverse their orientation, otherwise Part.Face fails
        for i in wires:
           i.reverse()

        # make sure that the exterior wires comes as first in the list
        wires.insert(0, ext)
        faces.append(Part.Face(wires))

shell=Part.Compound(faces)
Part.show(shell)
#solid = Part.Solid(Part.Shell(faces))
#Part.show(solid)